//+------------------------------------------------------------------+
//|                          HAMA Lines MA5 With Crossing Arrows.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|Original - HAMA Lines MA5 - From HAMA_20.mq4 mod by Raff     |
//+------------------------------------------------------------------+
// Watermark removed to eliminate screen display distraction         |
// Watermark credit "fxcruiser HAMA PAD"                             |
//+------------------------------------------------------------------+
//|1/5/2010 Mod and Notes - HAMA Lines MA5 With Crossing Arrows.mq4  |
//|Arrows by Robert with Code from Heiken Ashi Ma T3.mq4 TSD         |                                                |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com" // Indicators found on TSD Site
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6      //Added 2 buffers for MA Arrows
#property indicator_color1 Pink
#property indicator_color2 SkyBlue
#property indicator_color3 Pink
#property indicator_color4 SkyBlue
//#property indicator_buffers 2   // Added to above buffer count for Arrows
#property indicator_color5 Yellow // UpArrow Color
#property indicator_width5 1      // UpArrow Size
#property indicator_color6 Red    // DownArrow Color
#property indicator_width6 1      // DownArrow Size

//---- parameters
extern int MaMethod = 1;
extern int MaPeriod = 5;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//----
int    ExtCountedBars=0;
//-------From "Heiken Ashi MA T3"
double UpArrow[]; //ExtMapBuffer5[] 
double DnArrow[]; //ExtMapBuffer6[]
static bool TurnedUp   = false;
static bool TurnedDown = false;
datetime    timeprev   = 0;
//-----Added for user input for Arrow Size 
extern int width     = 1 ;
//-------From "Heiken Ashi MA T3"
extern int  Step      = 10;
extern int  CountBars = 4000;
extern bool Alerts    = true;
//-------------

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//|------------------------------------------------------------------|
int init()
  {
//---- indicators
   SetIndexStyle (0,DRAW_NONE, 0, 1, Pink); 
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle (1,DRAW_NONE, 0, 1, SkyBlue);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle (2,DRAW_LINE, 2, 0, Pink);
   SetIndexBuffer(2, ExtMapBuffer3);
   SetIndexStyle (3,DRAW_LINE, 2, 0, SkyBlue);
   SetIndexBuffer(3, ExtMapBuffer4);
//-----From Heiken Ashi MA T3 and other MA Cross 
   SetIndexStyle     (4,DRAW_ARROW,EMPTY,width); //arrow code up
   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer    (4, UpArrow);
   SetIndexStyle     (4,DRAW_ARROW);
   SetIndexArrow     (4,233);
   SetIndexStyle     (5,DRAW_ARROW,EMPTY,width); //arrow code down
   SetIndexEmptyValue(5,0.0);
   SetIndexBuffer    (5,DnArrow);
   SetIndexStyle     (5,DRAW_ARROW);
   SetIndexArrow     (5,234);
//----
   SetIndexDrawBegin(0,5);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,UpArrow);
   SetIndexBuffer(5,DnArrow);
//+------------------------------------------------------------------+
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   //------------From Heiken Ashi MA T3
   if(timeprev<iTime(NULL,0,0)) {TurnedDown=false; TurnedUp=false;timeprev=iTime(NULL,0,0);}
   if (CountBars>Bars-1) CountBars=Bars-1;
   //------------
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haHigh, haLow, haClose;
      
   if(Bars<=10) return(0);
   //----------
   int pos=CountBars;//-ExtCountedBars-1;
  
   while(pos>=0)
     {
      maOpen=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_OPEN,pos);
      maClose=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_CLOSE,pos);
      maLow=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_LOW,pos);
      maHigh=iMA(NULL,0,MaPeriod,0,MaMethod,MODE_HIGH,pos);

      haOpen=(ExtMapBuffer3[pos+1]+ExtMapBuffer4[pos+1])/2;
      haClose=(maOpen+maHigh+maLow+maClose)/4;
      haHigh=MathMax(maHigh, MathMax(haOpen, haClose));
      haLow=MathMin(maLow, MathMin(haOpen, haClose));
      
      if (haOpen<haClose) 
        {
         ExtMapBuffer1[pos]=haLow;
         ExtMapBuffer2[pos]=haHigh;
        } 
      else
        {
         ExtMapBuffer1[pos]=haHigh;
         ExtMapBuffer2[pos]=haLow;
        } 
      ExtMapBuffer3[pos]=haOpen;
      ExtMapBuffer4[pos]=haClose;
//------------From Heiken Ashi MA T3
 	   if (Step>0) if(MathAbs(ExtMapBuffer1[pos]-ExtMapBuffer1[pos+1]) < Step*Point)ExtMapBuffer1[pos]=ExtMapBuffer1[pos+1];
      if (Step>0) if(MathAbs(ExtMapBuffer2[pos]-ExtMapBuffer2[pos+1]) < Step*Point)ExtMapBuffer2[pos]=ExtMapBuffer2[pos+1];
      if (Step>0) if(MathAbs(ExtMapBuffer3[pos]-ExtMapBuffer3[pos+1]) < Step*Point)ExtMapBuffer3[pos]=ExtMapBuffer3[pos+1];
      if (Step>0) if(MathAbs(ExtMapBuffer4[pos]-ExtMapBuffer4[pos+1]) < Step*Point)ExtMapBuffer4[pos]=ExtMapBuffer4[pos+1];
      if (Alerts==true)
        {
         UpArrow[pos]=EMPTY_VALUE; DnArrow[pos]=EMPTY_VALUE;
         if (ExtMapBuffer3[pos]<ExtMapBuffer4[pos] && ExtMapBuffer4[pos+1]<ExtMapBuffer3[pos+1])
           {
            UpArrow[pos]=ExtMapBuffer4[pos+1]-(Ask-Bid);
            if (UpArrow[0]!=EMPTY_VALUE && TurnedUp==false)
              {
               //Alert("HAMA  BUY:  ",Symbol()," - ",Period(),"  at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
               TurnedDown =false;
               TurnedUp   =true;
              }
           }
         if (ExtMapBuffer3[pos]>ExtMapBuffer4[pos] && ExtMapBuffer4[pos+1]>ExtMapBuffer3[pos+1])
           {
            DnArrow[pos]=ExtMapBuffer4[pos+1]+(Ask-Bid);
            if (DnArrow[0]!=EMPTY_VALUE && TurnedDown==false)
              {
               //Alert("HAMA SELL:  ",Symbol()," - ",Period(),"  at  ", Close[0],"  -  ", TimeToStr(CurTime(),TIME_SECONDS));
               TurnedUp   =false;
               TurnedDown =true;
              }
           }
        }
 	   //------------
 	   pos--;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//+--------End of Program--------------------------------------------+


